
  /* pre GLCD_101 a GLCD_101a */



#include <stdbool.h>
#include "mcc_generated_files/mcc.h"

//  Fonty
//#include "Deco_Tech_24x52.h"
//#include "Deco_Tech_19x38.h"
//#include "Impact_23x40.h"
//#include "Impact_32x55.h"
//#include "Open_Sans_Semibold_25x34.h"
#include "OCR-A_BT_27x42.h"
//#include "Tahoma_30x46.h"
//#include "Times_New_Roman_28x41.h"

// k hodinam 
bit sekunda,
             bodka,
             Napajanie_ON;

bit Tlacidlo_1_stlacene=0,
    Tlacidlo_1_uvolnene=0,
    Tlacidlo_2_stlacene=0,
    Tlacidlo_2_uvolnene=0,
    aktualizuj_jednotky_minuty=0,
    aktualizuj_desiatky_minuty=0,
    aktualizuj_jednotky_hodiny=0,
    aktualizuj_desiatky_hodiny=0;


unsigned char ADC_result; 

unsigned char   sekundy, jednotky_minut, desiatky_minut, jednotky_hodin, desiatky_hodin;

unsigned char pocitadlo_stlpcov;

unsigned char   sekundy=0;
unsigned char   jednotky_minut=0;
unsigned char   desiatky_minut=0;
unsigned char   jednotky_hodin=0;
unsigned char   desiatky_hodin=0;


unsigned char pocitadlo_bodky=0;



//******************************************************************************************************
// k glcd display

// dvojbodka bodka
const unsigned char dvojbodka_on[] = {
0x02,0x04, 0x0F, 0xF0, 0x0F, 0xF0, 0x0F, 0xF0, 0x0F, 0xF0    // Code for char :
        };
const unsigned char dvojbodka_off[] = {
0x02,0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00    // Code for char :
        };


/* local function to generate delay */
void GLCD_Delay(int cnt)
{
    int i;
    for(i=0;i<cnt;i++);
}
 
// reset glcd - on
void GLCD_RES_ON()
{
GLCD_RES_SetLow();
}
// reset glcd - off
void GLCD_RES_OFF()
{
GLCD_RES_SetHigh();
}
// select page 0
void GlCD_SelectPage0() // CS1=1, CS2=0
{
    GLCD_CS1_SetHigh();
    GLCD_CS2_SetLow();
}
// select page 1
void GlCD_SelectPage1() // CS1=0, CS1=1
{
    GLCD_CS1_SetLow();
    GLCD_CS2_SetHigh();
}
// vystup na dataove piny glcd - potrebne definovat ako piny
void GLCD_Data_SET ( unsigned char data )
{
    GLCD_D0_SetLow();
    GLCD_D1_SetLow();
    GLCD_D2_SetLow();
    GLCD_D3_SetLow();
    GLCD_D4_SetLow();    
    GLCD_D5_SetLow();
    GLCD_D6_SetLow();
    GLCD_D7_SetLow();
    
    if(data&0b00000001) GLCD_D0_SetHigh();    
    if(data&0b00000010) GLCD_D1_SetHigh();
    if(data&0b00000100) GLCD_D2_SetHigh();
    if(data&0b00001000) GLCD_D3_SetHigh();
    if(data&0b00010000) GLCD_D4_SetHigh();
    if(data&0b00100000) GLCD_D5_SetHigh();
    if(data&0b01000000) GLCD_D6_SetHigh();
    if(data&0b10000000) GLCD_D7_SetHigh();
}    
// zapnutie glcd    
void GLCD_ON()
{
GLCD_RW_SetLow(); // zapis
GLCD_RS_SetLow(); // prikazu
GlCD_SelectPage0(); //set page 1
GLCD_Data_SET ( 0b00111111 ); // zapni dysplej

GLCD_E_SetHigh();
GLCD_Delay(11);
GLCD_E_SetLow();
GLCD_Delay(11);

GLCD_RW_SetLow(); // zapis
GLCD_RS_SetLow(); // prikazu
GlCD_SelectPage1(); //set page 1
GLCD_Data_SET ( 0b00111111 ); // zapni dysplej

GLCD_E_SetHigh();
GLCD_Delay(11);
GLCD_E_SetLow();
GLCD_Delay(11);
}
// vypnutie glcd
void GLCD_OFF()
{
GLCD_RW_SetLow(); // zapis
GLCD_RS_SetLow(); // prikazu
GlCD_SelectPage0(); //set page 1
GLCD_Data_SET ( 0b00111110 ); // zapni dysplej

GLCD_E_SetHigh();
GLCD_Delay(11);
GLCD_E_SetLow();
GLCD_Delay(11);

GLCD_RW_SetLow(); // zapis
GLCD_RS_SetLow(); // prikazu
GlCD_SelectPage1(); //set page 1
GLCD_Data_SET ( 0b00111110 ); // zapni dzsplej

GLCD_E_SetHigh();
GLCD_Delay(11);
GLCD_E_SetLow();
GLCD_Delay(11);
}
/* Function to send the command to LCD */
void GLCD_Cmd_Write(char cmd)
{
    GLCD_Data_SET ( cmd );  //Send the Command nibble
    GLCD_RS_SetLow();       // Send LOW pulse on RS pin for selecting Command register
    GLCD_RW_SetLow();       // Send LOW pulse on RW pin for Write operation
    GLCD_E_SetHigh();       // Generate a High-to-low pulse on EN pin
    GLCD_Delay(11);        // MIN 1000ns
    GLCD_E_SetLow();
    GLCD_Delay(11);
    
}
/* Function to send the Data to LCD */
void GLCD_Data_Write(char dat)
{
    GLCD_Data_SET ( dat );  //Send the data on DataBus nibble
    GLCD_RS_SetHigh();      // Send HIGH pulse on RS pin for selecting Command register
    GLCD_RW_SetLow();       // Send LOW pulse on RW pin for Write operation
    GLCD_E_SetHigh();       // Generate a High-to-low pulse on EN pin
    GLCD_Delay(11);         // MIN 1000ns
    GLCD_E_SetLow();
    GLCD_Delay(11);  
}

void GlCD_DisplayChar(char *ptr_array)
{
    int i;
    for(i=0;i<6;i++) GLCD_Data_Write(ptr_array[i]);
}
// zmaze displej
void GLCD_ClearScreen(void)
{
unsigned char riadky, stlpce;

GLCD_Cmd_Write(0x20);   // stlpce
GLCD_Cmd_Write(0xb8);   // riadky
GLCD_Cmd_Write(0xc0); // nastavit 0,0,0,

for(riadky = 0; riadky < 8; riadky++)
  {
  GLCD_Cmd_Write(riadky+0xb8);   // riadky
  for(stlpce = 0; stlpce < 65; stlpce++)
    GLCD_Data_Write(0x00);
  }
}

// GLCD_Bitmap(char * bmp, vlavo hore x, vlavo hore y )
// x , y kde sa zacne vykreslovat obrazok
// v char prvy znak pocet pouzitych riadkov
// druhy znak pocet stlpcov
void GLCD_Bitmap(char * bmp, unsigned char x, unsigned char y )
{
unsigned char bmp_riadok, bmp_stlpec, yz,xz, xk,yk ;

bmp_riadok = *bmp;           // rozmer obrazka x . riadky
bmp = bmp+1;
bmp_stlpec = *bmp;         // rozmer obrazka y . stlpce
xk = x/8;

for (yz=0; yz < bmp_stlpec; yz++  )
    {
    yk = 0x40+yz+y;

    for (xz=0; xz < bmp_riadok; xz++)
        {
        GLCD_Cmd_Write(yk);   // nastavit stlpce
        GLCD_Cmd_Write(0xB8+xz+xk);
        bmp = bmp+1;
        GLCD_Data_Write(*bmp);
        }
    }
}
/*****************************************************************************************************/

void pocitanie_casu(void) // pocitanie od sekunda
{
       
    if (sekunda)
        {
        sekundy=sekundy+2;
        
        bodka=1;
        pocitadlo_bodky=110;
        
        if(sekundy>=60) 
        {
            sekundy=0;
            jednotky_minut++;
            aktualizuj_jednotky_minuty = 1;
            if(jednotky_minut>=10)
            {
                jednotky_minut=0;
                aktualizuj_desiatky_minuty=1;
                desiatky_minut++;
                if (desiatky_minut>=6)
                {
                    desiatky_minut=0;
                    aktualizuj_jednotky_hodiny=1;
                    jednotky_hodin++;
                    if ((jednotky_hodin>=10 && desiatky_hodin<=1) || (jednotky_hodin>=4 && desiatky_hodin==2))
                    {
                        jednotky_hodin=0;
                        aktualizuj_desiatky_hodiny=1;
                        desiatky_hodin++;
                        if (desiatky_hodin>2)
                        {
                            desiatky_hodin=0;
                        }
                        else;
                    }
                    else;
                }
                else;
                }
            else;        
            }
        else;
        }
    else;
     sekunda=0;
}

void pripocitanie_casu_od_tlacidla(void)   // pripocitavanie od tlacidiel
{
    
    if(Tlacidlo_2_uvolnene)     
    {
        Tlacidlo_2_uvolnene=0;      // zmazat ze tlacidlo bolo zatlacene
        sekundy=0;                  // vynulovat sekundy
        TMR1_WriteTimer(0x0000);    // znulovat TMR1
        jednotky_minut++;
        aktualizuj_jednotky_minuty = 1;
        if(jednotky_minut>=10)
            {
                jednotky_minut=0;
                desiatky_minut++;
                aktualizuj_desiatky_minuty=1;
                if (desiatky_minut>=6)
                {
                    desiatky_minut=0;
                }
                else;
            }
            else;
    }
    else;
    
    if(Tlacidlo_1_uvolnene)     
    {
        Tlacidlo_1_uvolnene=0;      // zmazat ze tlacidlo bolo zatlacene
        sekundy=0;                  // vynulovat sekundy
        jednotky_hodin++;
        aktualizuj_jednotky_hodiny=1;
        TMR1_WriteTimer(0x0000);    // znulovat TMR1
        if ((jednotky_hodin>=10 && desiatky_hodin<=1) || (jednotky_hodin>=4 && desiatky_hodin==2))
        {
            jednotky_hodin=0;
            desiatky_hodin++;
            aktualizuj_desiatky_hodiny=1;
            if (desiatky_hodin>2)
            {
                desiatky_hodin=0;
            }
            else;
        }
        else;
    }
    else;
    
}

void detekcia_tlacidla(void)
{
//*************************************************    
//          detekcia tlacidla   
    if ( !TL_HOD_GetValue() ) Tlacidlo_1_stlacene=1;       // ak je stlacene
    if ( TL_HOD_GetValue() && Tlacidlo_1_stlacene )        // ak bolo stlacene
    {
        Tlacidlo_1_stlacene=0;
        Tlacidlo_1_uvolnene=1;
    };
//************************************************   
   
//************************************************  
    if ( !TL_MIN_GetValue() ) Tlacidlo_2_stlacene=1;
    if ( TL_MIN_GetValue() && Tlacidlo_2_stlacene )
    {
      Tlacidlo_2_stlacene=0;
      Tlacidlo_2_uvolnene=1;
    };
//************************************************      
}



void zobraz(unsigned char cislo,unsigned char poloha )
{
unsigned char x,y;


    switch(poloha)
        {
        case 0:
            {
            GlCD_SelectPage0(); 
            x=10;   // desiatky hodin
            y=1;    //  
            }
            break;
        case 1:
            {
            GlCD_SelectPage0();                 
            x=10;   // desiatky hodin
            y=30;    //  
            }
            break;
        case 2:
            {
            GlCD_SelectPage1(); 
            x=10;   // desiatky hodin
            y=5;    //  
            }
            break;
        case 3:
            {
            GlCD_SelectPage1();     
            x=10;   // desiatky hodin
            y=35;    //  
            }
            break;
        }
    
     
    
    switch(cislo)
        {
        case 0:
            if (poloha == 0)
            {
                GLCD_Bitmap(&bmp_10,x,y );
            }
            else
            {
                GLCD_Bitmap(&bmp_0,x,y );
            };
            
            break;
        case 1:
            GLCD_Bitmap(&bmp_1,x,y );
            break;
        case 2:
            GLCD_Bitmap(&bmp_2,x,y );
            break;
        case 3:
            GLCD_Bitmap(&bmp_3,x,y );
            break;
        case 4:
            GLCD_Bitmap(&bmp_4,x,y );
            break;
        case 5:
            GLCD_Bitmap(&bmp_5,x,y );
            break;   
        case 6:
            GLCD_Bitmap(&bmp_6,x,y );
            break;
        case 7:
            GLCD_Bitmap(&bmp_7,x,y );
            break;
        case 8:
            GLCD_Bitmap(&bmp_8,x,y );
            break;
        case 9:
            GLCD_Bitmap(&bmp_9,x,y );
            break;    
        }
}

void aktualizuj_zobrazenie(void)
{
    if (aktualizuj_desiatky_hodiny==1)
    {
        zobraz(desiatky_hodin,0x00 );
        aktualizuj_desiatky_hodiny=0;
    };

    if (aktualizuj_jednotky_hodiny==1)
    {
        zobraz(jednotky_hodin,0x01 );
        aktualizuj_jednotky_hodiny=0;
    };
    
    if (aktualizuj_desiatky_minuty==1)
    {
        zobraz(desiatky_minut,0x02 );
        aktualizuj_desiatky_minuty=0;
    };
    
    if (aktualizuj_jednotky_minuty==1)
    {
        zobraz(jednotky_minut,0x03 );
        aktualizuj_jednotky_minuty=0;
    };
    
}

/*************************************************************************************************/







//*************************************************************************************************

void main(void)
{
   // Initialize the device
   SYSTEM_Initialize();
 
   GLCD_RES_ON();
   GLCD_RES_OFF();
   GLCD_ON();
   GlCD_SelectPage0();
   GLCD_ClearScreen(); 
   GlCD_SelectPage1();
   GLCD_ClearScreen();     
  
   // If using interrupts in PIC18 High/Low Priority Mode you need to enable the Global High and Low Interrupts
    // If using interrupts in PIC Mid-Range Compatibility Mode you need to enable the Global and Peripheral Interrupts
    // Use the following macros to:

    
    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

  
 
   aktualizuj_desiatky_hodiny=1;
   aktualizuj_jednotky_hodiny=1; 
   aktualizuj_jednotky_minuty=1;          
   aktualizuj_desiatky_minuty=1;   
    
  

    
    while (1)
    {
        detekcia_tlacidla();
        pripocitanie_casu_od_tlacidla();
        pocitanie_casu();
        aktualizuj_zobrazenie();    
        
        if (bodka)
            {
                GlCD_SelectPage0();  
                GLCD_Bitmap(&dvojbodka_on,25,60);
                
                pocitadlo_bodky = pocitadlo_bodky-1;
                if (pocitadlo_bodky==0) bodka =0;
                
            }
        else
            {
                GlCD_SelectPage0();  
                GLCD_Bitmap(&dvojbodka_off,25,60 );
            };
    
    }
}
/**
 End of File
*/